﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Paypayes.Aelda.Core
{
    /// <summary>
    /// An ActorProxy is the client-side counterpart of an Actor. It shares the same SimulationObject id as its actor 
    /// and replicates the actor's revelant data. 
    /// </summary>
    public class ActorProxy : Performer
    {
        public ActorProxy(UInt64 id)
            : base(id)
        {
        }

        /// <summary>
        /// Process any client-side only behavior that does not need to be replicated by the server simulation, such
        /// as dynamic soudntrack selection or triggering of UI elements.
        /// </summary>
        public override void PerformAction(ActionState action)
        {
        }

        /// <summary>
        /// The client-side simulation will route all incoming events to the appropriate ActorProxy, where it will be 
        /// handled by the ReceiveEvent method.
        /// </summary>
        public override void ReceiveEvent(EventArgs e)
        {
        }

        /// <summary>
        /// Routes outbound action requests to the associated actor on the server.
        /// </summary>
        public void ProcessEventQueue()
        {
            throw new NotImplementedException();
        }
    }
}
