﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Paypayes.Aelda.Core
{
    public static class SobFactory
    {
        private static UInt64 _nextSobId;

        public static SimulationObject Create(SobType type, UInt64? id = null)
        {
            switch (type)
            {
                case SobType.Actor:
                    return new Actor(id ?? _nextSobId++);
                case SobType.Area:
                    return new Area(id ?? _nextSobId++);
                default:
                    return null;
            }
        }

    }
}
